/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2024 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const Bt=require("react"),C=require("prop-types"),o=require("@progress/kendo-react-common"),_t=require("@progress/kendo-react-labels"),et=require("@progress/kendo-svg-icons"),Ht=require("../common/ListContainer.js"),Wt=require("../common/ListFilter.js"),tt=require("../common/GroupStickyHeader.js"),Ut=require("../common/ListDefaultItem.js"),Gt=require("../common/List.js"),rt=require("../common/DropDownBase.js"),p=require("../common/utils.js"),jt=require("../package-metadata.js"),nt=require("@progress/kendo-react-buttons"),Yt=require("@progress/kendo-react-intl"),Ke=require("../messages/index.js"),pe=require("../common/constants.js"),Me=require("@progress/kendo-react-layout");function $t(h){const Y=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(h){for(const k in h)if(k!=="default"){const B=Object.getOwnPropertyDescriptor(h,k);Object.defineProperty(Y,k,B.get?B:{enumerable:!0,get:()=>h[k]})}}return Y.default=h,Object.freeze(Y)}const s=$t(Bt),Jt="Please select a value from the list!",me=s.forwardRef((h,Y)=>{o.validatePackage(jt.packageMetadata);const k=o.useUnstyled(),B=o.useId(h.id),r=o.usePropsContext(ot,h),{delay:at=P.delay,tabIndex:st=P.tabIndex,ignoreCase:ge=P.ignoreCase,size:$=P.size,rounded:be=P.rounded,fillMode:fe=P.fillMode,groupMode:Qt=P.groupMode}=r,ve=()=>{if(o.canUseDOM)return H.current&&H.current.ownerDocument||window.document},it=()=>{var e,n;(e=t==null?void 0:t.current)!=null&&e.wrapper&&((n=t==null?void 0:t.current)==null||n.wrapper.focus({preventScroll:!0}))},N=()=>{let e;return T.current!==void 0&&T.current!==null?e=T.current:r.value!==void 0?e=r.value:f.value!==void 0&&f.value!==null?e=f.value:r.defaultValue!==void 0&&r.defaultValue!==null&&(e=r.defaultValue),!p.isPresent(e)&&r.defaultItem!==void 0&&r.defaultItem!==null&&(e=r.defaultItem),e},lt=()=>{const{dataItemKey:e}=r,n=p.getFilteredData(h),i=N();return n.findIndex(u=>p.areSame(u,i,e))},De=()=>r.required!==void 0?r.required:P.required,we=()=>{const e=r.validationMessage!==void 0,n=N(),i=!De()||n!==null&&n!==""&&n!==void 0,u=r.valid!==void 0?r.valid:i;return{customError:e,valid:u,valueMissing:n===null}},ct=()=>r.validityStyles!==void 0?r.validityStyles:P.validityStyles,ee=e=>{ne.current=!0,e.focus(),window.setTimeout(()=>ne.current=!1,30)},Ie=()=>{Q.current&&ee(Q.current),r.adaptive&&setTimeout(()=>{Q.current&&ee(Q.current)},300)},dt=e=>{for(const n of e)n.target.clientWidth!==re.current.windowWidth&&U({windowWidth:n.target.clientWidth})},Pe=()=>{te.current&&te.current.setCustomValidity&&te.current.setCustomValidity(we().valid?"":r.validationMessage||Jt)},_=(e,n)=>{const i=N();p.areSame(i,e,r.dataItemKey)||(r.value===void 0&&(n.data.value=e),t.current.updateComponentArgs({value:e}),T.current=e,n.events.push({type:"onChange"}))},M=e=>{var n;(n=t==null?void 0:t.current)==null||n.applyState(e),T.current=void 0},J=(e,n)=>{var c;const{virtual:i,dataItemKey:u,defaultItem:d}=r,m=p.getFilteredData(h),I=i?i.skip:0,v=N(),a=e===-1&&d!==void 0?d:m[e-I],g=!p.areSame(a,v,u);_(a,n),g&&((c=t==null?void 0:t.current)==null||c.triggerPageChangeCornerItems(a,n))},O=(e,n,i)=>{var x,D;const{defaultItem:u,dataItemKey:d,virtual:m={skip:0,total:0,pageSize:0}}=r,I=N(),v=p.getFilteredData(h),a=(x=t==null?void 0:t.current)==null?void 0:x.vs,g=v.findIndex(y=>p.areSame(y,I,d)),c=(D=t==null?void 0:t.current)==null?void 0:D.navigation.navigate({current:m.skip+g,max:(a!=null&&a.enabled?m.total:v.length)-1,min:u!==void 0?-1:0,keyCode:n,skipItems:i||void 0});c!==void 0&&J(c,e),M(e)},ut=e=>{H.current=e,t.current.wrapper=e},pt=e=>s.createElement("select",{name:r.name,ref:n=>{te.current=n},tabIndex:-1,"aria-hidden":!0,title:r.label,style:{opacity:0,width:1,border:0,zIndex:-1,position:"absolute",left:"50%"}},s.createElement("option",{value:r.valueMap?r.valueMap.call(void 0,e):e})),ye=()=>{const{textField:e,dataItemKey:n,virtual:i={skip:0},focusedItemIndex:u=p.itemIndexStartsWith,filterable:d,skipDisabledItems:m=!0}=r,I=N(),v=p.getFilteredData(h),a=r.filter?r.filter:f.text;return m&&e&&!a&&!I?v.findIndex(g=>!g.disabled&&g[e]):p.isPresent(I)&&a===void 0||d&&a===""?v.findIndex(g=>p.areSame(g,I,n)):a?xe.current?u(v,a,e):v.findIndex(g=>p.areSame(g,I,n)):i.skip===0?0:-1},Fe=(e,n)=>n!==void 0&&n!==-1&&e&&e.length>0&&e[n].disabled,he=()=>{const e=p.getFilteredData(h),n=t.current.initState(),i=ye();Fe(e,i)&&(_(null,n),M(n))},Se=e=>{if(e.isPropagationStopped())return;const n=t.current.initState();n.syntheticEvent=e,f.focused||(n.data.focused=!0),he(),t.current.togglePopup(n),M(n)},Oe=e=>{var F,de,z,ue,j,Ze,Re;e&&e.target instanceof Element&&e.target.nodeName==="INPUT"&&e.stopPropagation&&e.stopPropagation();const{filterable:n,disabled:i,defaultItem:u,leftRightKeysNavigation:d=!0,virtual:m={skip:0,total:0,pageSize:0},dataItemKey:I,groupField:v="",textField:a,skipDisabledItems:g=!0}=r,c=p.getFilteredData(h),x=N(),D=c.findIndex(L=>p.areSame(L,x,I)),y=r.opened!==void 0?r.opened:f.opened,l=e.keyCode,b=l===o.Keys.home||l===o.Keys.end,K=l===o.Keys.up||l===o.Keys.down,G=!y&&(e.altKey&&l===o.Keys.down||l===o.Keys.enter||l===o.Keys.space),R=y&&(e.altKey&&l===o.Keys.up||l===o.Keys.esc),le=d&&(l===o.Keys.left||l===o.Keys.right),ce=K||le&&!n||b,E=t.current.initState();if(E.syntheticEvent=e,!i){if(b&&((F=t==null?void 0:t.current)!=null&&F.vs.enabled))l===o.Keys.home?m.skip!==0?((de=t==null?void 0:t.current)==null||de.triggerOnPageChange(E,0,m.pageSize),A.current=!0):_(c[0],E):m.skip<m.total-m.pageSize?((z=t==null?void 0:t.current)==null||z.triggerOnPageChange(E,m.total-m.pageSize,m.pageSize),A.current=!0):_(c[c.length-1],E);else if(y&&l===o.Keys.pageUp)e.preventDefault(),(ue=t==null?void 0:t.current)==null||ue.scrollPopupByPageSize(-1);else if(y&&l===o.Keys.pageDown)e.preventDefault(),(j=t==null?void 0:t.current)==null||j.scrollPopupByPageSize(1);else if(y&&l===o.Keys.enter){const L=ye();Fe(c,L)?(_(null,E),M(E)):J(L,E),(Ze=t==null?void 0:t.current)==null||Ze.togglePopup(E),e.preventDefault()}else if(G||R)R&&he(),(Re=t==null?void 0:t.current)==null||Re.togglePopup(E),e.preventDefault();else if(ce){if(xe.current=!1,v!==""&&a)if(!g&&y)O(E,l);else{let L;if(l===o.Keys.down||l===o.Keys.right){const S=c.slice(D+1).find(w=>!w.disabled&&w[a]);L=S&&c.findIndex(w=>w[a]===S[a])}else if(l===o.Keys.up||l===o.Keys.left){let S;if(D===0&&u)L=-1;else if(D===-1)S=c,L=c.findIndex(w=>!w.disabled&&w[a]);else{S=c.slice(0,D);let w=S.pop();for(;w&&w.disabled;)w=S.pop();L=w&&c.findIndex(Ne=>Ne[a]===w[a])}}if(L!==void 0){const S=L-D;O(E,l,S)}else L===void 0&&c.findIndex(S=>S[a]===x[a])===c.length-1&&O(E,l)}else if(!g&&y||b)O(E,l);else if(a){let L;if(l===o.Keys.down||l===o.Keys.right){const S=c.slice(D+1).find(w=>!w.disabled&&w[a]);L=S&&c.findIndex(w=>w[a]===S[a])}else if(l===o.Keys.up||l===o.Keys.left){let S;if(D===0&&u)L=-1;else if(D===-1)S=c,L=c.find(w=>!w.disabled&&w[a]);else{S=c.slice(0,D);let w=S.pop();for(;w&&w.disabled;)w=S.pop();L=w&&c.findIndex(Ne=>Ne[a]===w[a])}}if(L!==void 0){const S=L-D;O(E,l,S)}else L===void 0&&c.findIndex(S=>S[a]===x[a])===c.length-1&&O(E,l)}else O(E,l);e.preventDefault()}M(E)}},mt=e=>{const n=t.current.initState();n.syntheticEvent=e.syntheticEvent,r.filter===void 0&&(n.data.text=e.target.value),t.current.filterChanged(e.target.value,n),xe.current=!0,M(n),U({group:void 0,text:String(e.target.value)})},Te=()=>{const e=r.filter!==void 0?r.filter:f.text;return r.filterable&&s.createElement(Wt,{value:e,ref:n=>Q.current=n&&n.element,onChange:mt,onKeyDown:Oe,size:$,rounded:be,fillMode:fe,renderListFilterWrapper:!0})},gt=e=>{var i;const n=t.current.initState();n.syntheticEvent=e,(i=t==null?void 0:t.current)==null||i.togglePopup(n),_(r.defaultItem,n),M(n)},Ae=()=>{const{textField:e,defaultItem:n,dataItemKey:i}=r,u=N();return n!==void 0&&s.createElement(Ut,{defaultItem:n,textField:e,selected:p.areSame(u,n,i),key:"defaultitemkey",onClick:gt})},ft=(e,n)=>{var i;(i=t==null?void 0:t.current)==null||i.handleItemClick(e,n),T.current=void 0},vt=e=>{const{vs:n,list:i}=t.current;n.scrollHandler(e);const{groupField:u}=r;let d=p.getFilteredData(h);if(!(!u||!d.length)&&u){const m=Be.current=Be.current||(n.enabled?n.itemHeight:i?i.children[0].offsetHeight:0),v=e.target.scrollTop-n.skip*m;d=t.current.getGroupedDataModernMode(d,u);let a=d[0][u];for(let g=1;g<d.length&&!(m*g>v);g++)d[g]&&d[g][u]&&(a=d[g][u]);a!==f.group&&U({group:a})}},qe=()=>{var l;const{textField:e,dataItemKey:n,virtual:i={skip:0,total:void 0},groupHeaderItemRender:u,listNoDataRender:d,itemRender:m}=r,I=p.getFilteredData(h),v=k&&k.uDropDownList,a=t.current.vs,g=i.skip,c=r.opened!==void 0?r.opened:f.opened,x=t.current.getPopupSettings(),D=`translateY(${a.translate}px)`,y=N();return s.createElement(Gt,{id:Ee,show:c,data:I.slice(),focusedIndex:ye(),value:y,textField:e,valueField:n,optionsGuid:We,groupField:r.groupField,groupMode:"modern",listRef:b=>a.list=t.current.list=b,wrapperStyle:{maxHeight:x.height},wrapperCssClass:o.classNames(o.uDropDownList.listContent({c:v})),listStyle:a.enabled?{transform:D}:void 0,key:"listkey",skip:g,onClick:ft,itemRender:m,groupHeaderItemRender:u,noDataRender:d,onScroll:vt,wrapperRef:a.scrollerRef,scroller:(l=t==null?void 0:t.current)==null?void 0:l.renderScrollElement(),ariaSetSize:i.total})},Dt=()=>{var y;const{windowWidth:e=0}=f,{header:n,footer:i,adaptiveTitle:u,groupField:d,groupStickyHeaderItemRender:m,list:I}=r,v=p.getFilteredData(h),a=r.opened!==void 0?r.opened:f.opened,g=k&&k.uDropDownList,c=k&&k.uDropDownsActionSheet,x={navigatable:!1,navigatableElements:[],expand:a,animation:!0,onClose:l=>Se(l),animationStyles:e<=pe.MOBILE_SMALL_DEVISE?{top:0,width:"100%",height:"100%"}:void 0,className:o.classNames(o.uDropDownsActionSheet.wrapper({c,isFullScreen:e<=pe.MOBILE_SMALL_DEVISE}))};let{group:D}=f;return D===void 0&&d!==void 0&&(D=p.getItemValue(v[0],d)),s.createElement(Me.ActionSheet,{...x},s.createElement(Me.ActionSheetHeader,{className:o.classNames(o.uDropDownsActionSheet.header({c}))},s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.titleBar({c}))},s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.title({c}))},s.createElement("div",null,u)),s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.actions({c}))},s.createElement(nt.Button,{tabIndex:0,"aria-label":"Cancel","aria-disabled":"false",type:"button",fillMode:"flat",onClick:Se,icon:"x",svgIcon:et.xIcon}))),s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.titleBarGroup({c}))},Te())),s.createElement(Me.ActionSheetContent,{overflowHidden:!0},n&&s.createElement("div",{className:o.classNames(o.uDropDownList.listHeader({c:g}))},n),s.createElement("div",{className:o.classNames(o.uDropDownList.list({c:g,size:$,virtual:(y=t==null?void 0:t.current)==null?void 0:y.vs.enabled}))},Ae(),!I&&D&&v.length!==0&&s.createElement(tt,{group:D,groupMode:"modern",render:m}),qe()),i&&s.createElement("div",{className:o.classNames(o.uDropDownList.listFooter({c:g}))},i)))},wt=()=>{f.focused&&window.setTimeout(()=>{f.focused&&t.current.wrapper&&ee(t.current.wrapper)})},It=e=>{var n;(n=r.popupSettings)!=null&&n.onMouseDownOutside&&r.popupSettings.onMouseDownOutside.call(void 0,e)},yt=()=>{const{header:e,footer:n,dir:i,groupField:u,groupStickyHeaderItemRender:d,list:m}=r,I=p.getFilteredData(h),v=t.current,a=v.getPopupSettings(),g=r.opened!==void 0?r.opened:f.opened,c=a.width!==void 0?a.width:v.popupWidth,x=k&&k.uDropDownList,D={dir:i!==void 0?i:v.dirCalculated,width:c,popupSettings:{...a,popupClass:o.classNames(a.popupClass,o.uDropDownList.listContainer({c:x})),anchor:a.anchor||H.current,show:g,onOpen:Ie,onClose:wt,onMouseDownOutside:It},itemsCount:[I.length]};let{group:y}=f;return y===void 0&&u!==void 0&&(y=p.getItemValue(I[0],u)),s.createElement(Ht,{...D},Te(),e&&s.createElement("div",{className:o.classNames(o.uDropDownList.listHeader({c:x}))},e),s.createElement("div",{className:o.classNames(o.uDropDownList.list({c:x,size:$,virtual:t.current.vs.enabled}))},Ae(),!m&&y&&I.length!==0&&s.createElement(tt,{group:y,groupMode:"modern",render:d}),qe()),n&&s.createElement("div",{className:o.classNames(o.uDropDownList.listFooter({c:x}))},n))},ht=e=>{const{dataItemKey:n}=r,i=p.getFilteredData(h),u=N();let d=i.map((K,G)=>({item:K,itemIndex:G}));const m=W.current.word,I=W.current.last,v=p.sameCharsOnly(m,I);let a=d.length,g=Math.max(0,i.findIndex(K=>p.areSame(K,u,n))),c;r.defaultItem&&(c={item:r.defaultItem,itemIndex:-1},a+=1,g+=1),g+=v?1:0,d=p.shuffleData(d,g,c);let x,D,y,l=0;const{textField:b}=r;for(;l<a;l++)if(x=p.getItemValue(d[l].item,b),D=v&&p.matchText(x,I,ge),y=p.matchText(x,m,ge),D||y){l=d[l].itemIndex;break}if(l!==a){const K=t.current.initState();K.syntheticEvent=e,J(l,K),M(K),T.current=void 0}},St=e=>{clearTimeout(ze.current),r.filterable||(ze.current=window.setTimeout(()=>W.current.word="",at),ht(e))},xt=e=>{ne.current||t.current.handleFocus(e)},Et=e=>{if(ne.current||!f.focused)return;const n=r.opened!==void 0?r.opened:f.opened,{adaptive:i}=r,{windowWidth:u=0}=f,d=u<=pe.MOBILE_MEDIUM_DEVISE&&i,m=t.current.initState();m.syntheticEvent=e,m.data.focused=!1,m.events.push({type:"onBlur"}),n&&he(),n&&!d&&t.current.togglePopup(m),M(m)},Lt=e=>{if(r.filterable||e.which===0||e.keyCode===o.Keys.enter)return;let n=String.fromCharCode(e.charCode||e.keyCode);ge&&(n=n.toLowerCase()),n===" "&&e.preventDefault(),W.current={word:W.current.word+n,last:W.current.last+n},St(e)},Ct=()=>{const e=t.current.initState();e.data.opened=f.opened,t.current.togglePopup(e),M(e)},Ve=s.useRef(null),H=s.useRef(null),te=s.useRef(),Q=s.useRef(null);s.useImperativeHandle(Ve,()=>({get element(){return H.current},get index(){return lt()},get name(){return r.name},get validity(){return we()},get value(){return N()},get focused(){return f.focused},get opened(){return f.opened},focus:it,props:r,togglePopup:Ct})),s.useImperativeHandle(Y,()=>Ve.current);const ze=s.useRef(null),W=s.useRef({word:"",last:""}),ne=s.useRef(!1),T=s.useRef(null),A=s.useRef(!1),xe=s.useRef(!1),q=s.useRef({}),re=s.useRef({}),t=s.useRef(new rt({props:h,setState:()=>{},state:{},forceUpdate:()=>{},element:null,value:null,handleItemSelect:()=>{}})),Be=s.useRef(0),X=s.useRef(null),[f,kt]=s.useState({}),[,_e]=s.useReducer(e=>e,!0),Nt=Yt.useLocalization(),U=e=>{kt({...f,...e})};s.useEffect(()=>{t.current.updateComponentArgs({props:h,setState:U,state:f,forceUpdate:_e,element:H.current,handleItemSelect:J,value:N()})},[U,f,_e,J,N]),s.useEffect(()=>{var g,c,x,D,y,l,b,K,G,R,le,ce,E;const{dataItemKey:e,virtual:n,groupField:i="",textField:u}=r,d=p.getFilteredData(h),m=q.current.virtual?q.current.virtual.total:0,I=r.opened!==void 0?r.opened:f.opened,v=q.current.opened!==void 0?q.current.opened:re.current.opened,a=!v&&I;if((g=t==null?void 0:t.current)==null||g.didUpdate(),(c=t==null?void 0:t.current)!=null&&c.getPopupSettings().animate||a&&Ie(),n&&n.total!==m)(x=t==null?void 0:t.current)==null||x.vs.calcScrollElementHeight(),(D=t==null?void 0:t.current)==null||D.vs.reset();else{const F=N(),de=q.current.value!==void 0?q.current.value:re.current.value;let z=d.findIndex(j=>p.areSame(j,F,e));i!==""&&F&&u&&(z=(l=(y=t==null?void 0:t.current)==null?void 0:y.getGroupedDataModernMode(d,i))==null?void 0:l.map(j=>j[u]).indexOf(F[u]));const ue=!p.areSame(de,F,e);a&&n?(b=t==null?void 0:t.current)==null||b.scrollToVirtualItem(n,z):a&&!n?(Ie(),d&&d.length!==0&&((K=t==null?void 0:t.current)==null||K.resetGroupStickyHeader(d[0][i],{setState:U,group:f.group,state:f})),(G=t==null?void 0:t.current)==null||G.scrollToItem(z)):I&&v&&F&&ue&&!A.current?(le=t==null?void 0:t.current)==null||le.scrollToItem(z,(R=t==null?void 0:t.current)==null?void 0:R.vs.enabled):I&&v&&A.current&&(A.current&&n&&n.skip===0?(ce=t==null?void 0:t.current)==null||ce.vs.reset():A.current&&n&&n.skip===n.total-n.pageSize&&((E=t==null?void 0:t.current)==null||E.vs.scrollToEnd()))}A.current=!1,re.current=f,q.current=r,Pe()}),s.useEffect(()=>{var e,n;return X.current=o.canUseDOM&&window.ResizeObserver&&new window.ResizeObserver(i=>dt(i)),(e=t==null?void 0:t.current)==null||e.didMount(),Pe(),(n=ve())!=null&&n.body&&X.current&&X.current.observe(ve().body),()=>{var i;(i=ve())!=null&&i.body&&X.current&&X.current.disconnect()}},[]);const He=B+"-accessibility-id",Ee=B+"-listbox-id",We=B+"-guid",Kt=Nt.toLanguageString(Ke.dropDownListArrowBtnAriaLabel,Ke.messages[Ke.dropDownListArrowBtnAriaLabel]),{style:oe,className:Mt,label:Le,dir:bt,virtual:V,adaptive:Pt,dataItemKey:Ft,disabled:ae,loading:Ue,iconClassName:Ge,svgIcon:je,valueRender:Ye}=r,{windowWidth:Ot=0}=f,Ce=r.opened!==void 0?r.opened:f.opened,se=N(),ke=p.getItemValue(se,r.textField),$e=!ct()||we().valid,ie=t.current,Tt=ie.vs,Je=Ot<=pe.MOBILE_MEDIUM_DEVISE&&Pt,Z=k&&k.uDropDownList;Tt.enabled=V!==void 0,V!==void 0&&(ie.vs.skip=V.skip,ie.vs.total=V.total,ie.vs.pageSize=V.pageSize);const At=p.getFilteredData(h),{focused:qt}=f,Vt=At.findIndex(e=>p.areSame(e,se,Ft)),Qe=s.createElement("span",{id:He,className:o.classNames(o.uDropDownList.inputInner({c:Z}))},ke&&s.createElement("span",{className:o.classNames(o.uDropDownList.inputText({c:Z}))},ke)),zt=Ye!==void 0?Ye.call(void 0,Qe,se):Qe,Xe=s.createElement(s.Fragment,null,s.createElement("span",{ref:ut,className:o.classNames(o.uDropDownList.wrapper({c:Z,size:$,rounded:be,fillMode:fe,focused:qt,disabled:ae,invalid:!$e,loading:Ue,required:De()}),Mt),style:Le?{...oe,width:void 0}:oe,dir:bt,onMouseDown:Ce?e=>{e.target.nodeName!=="INPUT"&&(ee(t.current.wrapper),e.preventDefault())}:void 0,onFocus:xt,onBlur:Et,tabIndex:o.getTabIndex(st,ae),accessKey:r.accessKey,onKeyDown:Oe,onKeyPress:Lt,onClick:ae?void 0:Se,role:"combobox","aria-required":De(),"aria-disabled":ae||void 0,"aria-haspopup":"listbox","aria-expanded":Ce||!1,"aria-owns":Ee,"aria-activedescendant":Ce?"option-"+We+"-"+(Vt+(V?V.skip:0)):void 0,"aria-label":r.ariaLabel||r.label,"aria-labelledby":r.ariaLabelledBy,"aria-describedby":r.ariaDescribedBy||He,"aria-controls":Ee,id:r.id,title:r.title},zt,Ue&&s.createElement(o.IconWrap,{className:o.classNames(o.uDropDownList.loadingIcon({c:Z})),name:"loading"}),s.createElement(nt.Button,{tabIndex:-1,type:"button","aria-label":Kt,size:$,fillMode:fe,iconClass:Ge,className:o.classNames(o.uDropDownList.inputButton({c:Z})),rounded:null,themeColor:"base",icon:Ge?void 0:"caret-alt-down",svgIcon:je||et.caretAltDownIcon,onMouseDown:e=>f.focused&&e.preventDefault()}),pt(se),!Je&&yt()),Je&&Dt());return Le?s.createElement(_t.FloatingLabel,{label:Le,editorValue:ke,editorValid:$e,editorDisabled:r.disabled,style:{width:oe?oe.width:void 0},children:Xe}):Xe});me.propTypes={delay:C.number,ignoreCase:C.bool,iconClassName:C.string,svgIcon:o.svgIconPropType,defaultItem:C.any,valueRender:C.func,valueMap:C.func,validationMessage:C.string,required:C.bool,id:C.string,ariaLabelledBy:C.string,ariaDescribedBy:C.string,ariaLabel:C.string,leftRightKeysNavigation:C.bool,title:C.string,groupField:C.string,list:C.any,skipDisabledItems:C.bool};const P={delay:500,tabIndex:0,ignoreCase:!0,...rt.defaultProps,required:!1,size:"medium",rounded:"medium",fillMode:"solid",groupMode:"modern"};me.displayName="KendoReactDropDownList";const ot=o.createPropsContext();me.displayName="KendoReactDropDownList";exports.DropDownList=me;exports.DropDownListPropsContext=ot;exports.dropDownListDefaultProps=P;
